% Make OOS figures

% first, just plot evolution of coeffs
close all;

xdates = gwmerged.date(~isnan(x),1); 
plotdates = tdatetomatlab(xdates(params.ntraining+1:end,1));

% Create figure
figure1 = figure;

pos = [100 100 600 275 ] ;

figure1.Position = pos; 

% Create axes
axes1 = axes('Parent',figure1,...
    'XTick',datenum(1950:5:2010,1,1),'FontName','CMU Serif');
title([ varname ', predicting next-' num2str(params.nfutperiods) ' month returns']); 
ylabel('Rolling estimate of \it{b}'); 

box(axes1,'on');
hold(axes1,'on');

plot1 = plot(plotdates,[oosrsq.ols_coeff oosrsq.wls_coeff ],'Color',[ 0 0 0 ]); 

set(plot1(1),'LineStyle','-.');

legend('OLS','WLS-EV','Location','South','Orientation','Horizontal'); 
set(gcf,'Color',[1 1 1]); 
xlim([ min(plotdates) max(plotdates) ]); 
ylim([ axes1.YLim(1)-0.1*(axes1.YLim(2)-axes1.YLim(1)) axes1.YLim(2) ]); 
datetick('x','yyyy','keeplimits'); 

export_fig(gcf,[ params.base_folder varname '_ooscoeff_' num2str(params.nfutperiods) '.png'],'-r600'); 

% now, plot goyal welch style cumulative oos improvement
figure2 = figure; 

figure2.Position = pos; 
% Create axes
axes2 = axes('Parent',figure2,...
    'XTick',datenum(1950:5:2010,1,1),'FontName','CMU Serif');
% xlabel('\tau'); 
title([ varname ', predicting next-' num2str(params.nfutperiods) ' month returns']); 
ylabel('Cumulative forecast improvement'); 

box(axes2,'on');
hold(axes2,'on');

plot1 = plot(plotdates(params.nfutperiods+1:end),oosrsq.wls_cumimprovement-oosrsq.ols_cumimprovement,'Color',[ 0 0 0 ]); 

legend2 = legend('WLS-EV$-$OLS','Location','South','Orientation','Horizontal'); 
set(legend2,'Interpreter','latex');
set(gcf,'Color',[1 1 1]); 
xlim([ min(plotdates) max(plotdates) ]); 
ylim([ axes2.YLim(1)-0.1*(axes2.YLim(2)-axes2.YLim(1)) axes2.YLim(2) ]); 
datetick('x','yyyy','keeplimits'); 

export_fig(gcf,[ params.base_folder varname '_oosimprovement_' num2str(params.nfutperiods) '.png'],'-r600'); 