function [ dce ] = oosdce(r,rf,x,sigsq,realvar,params)
% function [ dce ] = oosdce(r,x,rf,sigsq,realvar,params)
% sigsq used on rhs of first-stage regression in wls-ev!
% must be simple r not log r

T = length(r)-params.nfutperiods; 
K = size(x,2); 

% Redo x so we are estimating the t+1,t+nfutperiods overlapping
% predicability
% these are rhs and lhs for rolling oos regressions
rhs_reg = makerhs(x,params.nfutperiods); 
lhs_reg = r(1+params.nfutperiods:end,1); 

% this is lhs/rhs we use in measuring ex-post performance
cpr = cumprod(1+r); 
lhs_remkt = cpr(1+params.nfutperiods:end)./cpr(1:end-params.nfutperiods)-1; 
% csr = cumsum(r); 
% lhs_remkt = csr(1+params.nfutperiods:end) - csr(1:end-params.nfutperiods); 
rhs_outcome = [ones(T,1) x(1:end-params.nfutperiods,1)]; 

cpr = cumprod(1+rf); 
lhs_rf = cpr(1+params.nfutperiods:end)./cpr(1:end-params.nfutperiods)-1; 

ols_coeff = zeros(length(r),1); 
ols_predy = zeros(length(r),1); 
ols_ct_predy = zeros(length(r),1); 
ols_ptv_coeff = zeros(length(r),1); 
ols_ptv_predy = zeros(length(r),1); 

wls_coeff = zeros(length(r),1); 
wls_predy = zeros(length(r),1); 
wls_ct_predy = zeros(length(r),1);
wls_ptv_coeff = zeros(length(r),1);
wls_ptv_predy = zeros(length(r),1);

oos_predvar = zeros(length(r),1); 

simple_avg = zeros(length(r),1); 

fprintf('%3d%%',0);
% OOS
% if( params.dooos )
% for j = params.ntraining+1:length(lhs_rsq)
for j = params.ntraining+1:length(r)
    pastrhs = makerhs(x(1:j,1),params.nfutperiods); 
    pastlhs = r(1+params.nfutperiods:j,1); 
    
    pastrhs_outcome = rhs_outcome(1:j-params.nfutperiods,:); 
    pastlhs_outcome = lhs_remkt(1:j-params.nfutperiods,1); 
    
    pastsigsq = sigsq(params.nfutperiods:j-1,:); 
    pastrealvar = realvar(1+params.nfutperiods:j,:); 
    
    ols_bv = pastrhs \ pastlhs; 
    ols_bv_rsq(2,1) = ols_bv(2,1)*var(rhs_reg)/var(rhs_outcome); 
    ols_bv_rsq(1,1) = mean(pastlhs_outcome) - ols_bv_rsq(2,1)*mean(pastrhs_outcome(:,2)); 
    ols_coeff(j,1) = ols_bv_rsq(2,1);
    ols_predy(j,1) = [1 x(j,:)]*ols_bv_rsq;

    [wls_bv, ~, ~, ~, ~, wlsev_firststage] = wlsev(pastlhs,pastrhs,pastsigsq,0,-1,pastrealvar); 
    wls_bv_rsq(2,1) = wls_bv(2,1)*var(rhs_reg)/var(rhs_outcome); 
    wls_bv_rsq(1,1) = mean(pastlhs_outcome) - wls_bv_rsq(2,1)*mean(pastrhs_outcome(:,2)); 
    wls_coeff(j,1) = wls_bv_rsq(2,1);
    wls_predy(j,1) = [1 x(j,:)]*wls_bv_rsq; 

    simple_avg(j,1) = mean(pastlhs_outcome);  

    oos_predvar(j,1) = [1 sigsq(j,:)]*wlsev_firststage.predvar_coeff*params.nfutperiods; 
    
    if( sign(ols_coeff(j,1)) ~= params.ct_sign )
        ols_ct_predy(j,1) = simple_avg(j,1);
    elseif(  ols_predy(j,1) < 0 )
        ols_ct_predy(j,1) = 0; 
    else 
        ols_ct_predy(j,1) = ols_predy(j,1);
    end

    if( sign(wls_coeff(j,1)) ~= params.ct_sign )
        wls_ct_predy(j,1) = simple_avg(j,1);
    elseif(  wls_predy(j,1) < 0 )
        wls_ct_predy(j,1) = 0; 
    else
        wls_ct_predy(j,1) = wls_predy(j,1);
    end

    % compute ptv coeff & predy using OLS
    ols_bv_ptv = wls_ptv(pastlhs,pastrhs,ones(length(pastlhs),1),wlsev_firststage.predvar,params.ptv_minsr,params.ptv_maxsr); 
    ols_bv_ptv_rsq(2,1) = ols_bv_ptv(2,1)*var(rhs_reg)/var(rhs_outcome); 
    ols_bv_ptv_rsq(1,1) = mean(pastlhs_outcome) - ols_bv_ptv_rsq(2,1)*mean(pastrhs_outcome(:,2)); 
    ols_ptv_coeff(j,1) = ols_bv_ptv_rsq(2,1);
    ols_ptv_predy(j,1) = [1 x(j,:)]*ols_bv_ptv_rsq;

    % compute ptv coeff & predy using OLS
    % for this, need wls-ev weights!
    wls_bv_ptv = wls_ptv(pastlhs,pastrhs,1./wlsev_firststage.predvar,wlsev_firststage.predvar,params.ptv_minsr,params.ptv_maxsr); 
    wls_bv_ptv_rsq(2,1) = wls_bv_ptv(2,1)*var(rhs_reg)/var(rhs_outcome); 
    wls_bv_ptv_rsq(1,1) = mean(pastlhs_outcome) - wls_bv_ptv_rsq(2,1)*mean(pastrhs_outcome(:,2)); 
    wls_ptv_coeff(j,1) = wls_bv_ptv_rsq(2,1);
    wls_ptv_predy(j,1) = [1 x(j,:)]*wls_bv_ptv_rsq;
    
    % update display
    fprintf('\b\b\b\b%3d%%',floor(100*(j-params.ntraining+1)/(length(r)-params.ntraining+1)));
end
fprintf('\b\b\b\bDone\n'); 
% end

% outcomes we will use for ex-post benchmark
lhs_remkt = lhs_remkt(params.ntraining+1:end,:); 
lhs_rf = lhs_rf(params.ntraining+1:end,:);

% ols_coeff = ols_coeff(params.ntraining+1:end,:);
ols_predy = ols_predy(params.ntraining+1:end-params.nfutperiods,:);
% wls_coeff = wls_coeff(params.ntraining+1:end,:);
wls_predy = wls_predy(params.ntraining+1:end-params.nfutperiods,:);

ols_ct_predy = ols_ct_predy(params.ntraining+1:end-params.nfutperiods,:);
wls_ct_predy = wls_ct_predy(params.ntraining+1:end-params.nfutperiods,:);

% ols_ptv_coeff = ols_ptv_coeff(params.ntraining+1:end,:); 
ols_ptv_predy = ols_ptv_predy(params.ntraining+1:end-params.nfutperiods,:); 
% wls_ptv_coeff = wls_ptv_coeff(params.ntraining+1:end,:); 
wls_ptv_predy = wls_ptv_predy(params.ntraining+1:end-params.nfutperiods,:); 

simple_avg = simple_avg(params.ntraining+1:end-params.nfutperiods,:);
    
oos_predvar = oos_predvar(params.ntraining+1:end-params.nfutperiods,:); 

gamma = 2*mean(lhs_remkt)/var(lhs_remkt); 
disp(['gamma = ' num2str(gamma)]);

ce_simple = makece(simple_avg,oos_predvar,lhs_remkt,lhs_rf,gamma,params.nfutperiods); 
ce_ols = makece(ols_predy,oos_predvar,lhs_remkt,lhs_rf,gamma,params.nfutperiods); 
ce_ols_ct = makece(ols_ct_predy,oos_predvar,lhs_remkt,lhs_rf,gamma,params.nfutperiods); 
ce_ols_ptv = makece(ols_ptv_predy,oos_predvar,lhs_remkt,lhs_rf,gamma,params.nfutperiods); 
ce_wls = makece(wls_predy,oos_predvar,lhs_remkt,lhs_rf,gamma,params.nfutperiods); 
ce_wls_ct = makece(wls_ct_predy,oos_predvar,lhs_remkt,lhs_rf,gamma,params.nfutperiods); 
ce_wls_ptv = makece(wls_ptv_predy,oos_predvar,lhs_remkt,lhs_rf,gamma,params.nfutperiods);

dce.ce_simple = ce_simple;
dce.ols = ce_ols - ce_simple; 
dce.ols_ct = ce_ols_ct - ce_simple; 
dce.ols_ptv = ce_ols_ptv - ce_simple; 
dce.wls = ce_wls - ce_simple; 
dce.wls_ct = ce_wls_ct - ce_simple; 
dce.wls_ptv = ce_wls_ptv - ce_simple; 

end

function ce = makece(predremkt,predvar,remkt,rf,gamma,nfutperiods)
    weight = min((1/gamma)*predremkt./predvar,1.5); 
    ce = (1+mean(rf+weight.*remkt) - (gamma/2)*var(rf + weight.*remkt))^(12/nfutperiods)-1; 
end

function rhs = makerhs(x,nfutperiods)
    rollx = conv(x,ones(1,nfutperiods),'valid'); 
    rollx = rollx(~isnan(rollx),1); 
%     rollx = rollx*var(x)/var(rollx); % DON'T NEED TO DO THIS HERE BECAUSE
%     WE SCALE ELSEWHERE

    rhs = [ ones(length(x)-nfutperiods,1) rollx(1:end-1,1) ];  
end