function [ coeff ] = wls_ptv_old(lhs,rhs,w,sigsq,minsr,maxsr,init_coeff)
%function [ coeff ] = wls_ptv_old(lhs,rhs,w,sigsq,minsr,maxsr,init_coeff) 
% Computes wls-ev using the Pettenuzzo Timmerman Valkanov (2013)
% restrictions on the point estimates

    options = optimset('display','none','algorithm','active-set', ...
        'maxfunevals',1000); 
    
%   This is our objective function   
    function V = objfun(coeff)
        epsilon = lhs - rhs*coeff; 
        
%         V = sum( w.*(epsilon.^2) ) / sum( w.*(lhs-mean(lhs)).^2 );
        V = sum( w.*(epsilon.^2) );
    end

%   These are our constraints (need to have conditional SR always between
%   minsr and maxsr
    function [c,ceq] = myconst(coeff)
        rhat = rhs*coeff; 
        srhat = rhat ./ sqrt(sigsq); 
        
        c = max(max( minsr - srhat, srhat - maxsr ));
        ceq = [];
        
        if( sum(isnan(c)) || sum(isnan(ceq)) > 0 )
            disp('wtf'); 
        end
    end

    init_coeff = [ mean(lhs); zeros(size(rhs,2)-1,1) ]; 
    coeff = fmincon(@objfun,init_coeff,[],[],[],[],[],[],@myconst,options);
end